import Taro, { Component } from '@tarojs/taro'
import { Map } from '@tarojs/components'

const makerIcon = require('@assets/icons/marker.png')
const makerCheckedIcon = require('@assets/icons/marker_checked.png')


export default class PoiAround extends Component {

  state = {
    current: undefined,
  }

  markerTap = false

  handleTap = (e) => {
    const inx = e.markerId
    this.markerTap = true
    this.setState({ current: inx }, () => {
      const marker = this.props.markers.filter((_, i) => i=== inx)[0]
      this.props.onMarkerClick && this.props.onMarkerClick(marker)
    })
  }

  render() {
    const { current } = this.state
    const markers =  (this.props.markers || []).map((marker, index) => {
      return {
        id: marker.id,
        latitude: marker.latitude,
        longitude: marker.longitude,
        iconPath: index === current && this.markerTap ? makerCheckedIcon : makerIcon,
        width: marker.width,
        height: marker.height,
        alpha: 0.7,
        title: index + 1,
        label: {
          content: index + 1,
          // borderRadius: 1000,
          color: '#fff',
          bgColor: '#f00',
          textAlign: 'center',
        },
      }
    })

    this.markerTap = false

    return this.props.longitude && (
      <Map
        showLocation
        scale={12}
        markers={markers}
        longitude={this.props.longitude}
        latitude={this.props.latitude}
        onMarkerTap={this.handleTap}
      />
    )
  }
}
